Windows7のRuby 2.3.1にてNokogiriを使えるようになるまでを書いていきます。
Ruby 2.3.1をWindowsで使用できるようにするまではWindowにてRubyの実行環境を構築するを参考にしてください。

DevKitのインストール

Nokogiriを使えるようにするにはまずDevKitと言うものをインストールする必要があります。 以下のリンクよりダウンロードしてください。

http://rubyinstaller.org/downloads/
ページ内の少し下にあります。
devkit
お使いのWindowsのbitに合わせてダウンロードしてください。
ダウンロードしたら好きな場所にディレクトリを作成し、ファイルを実行、展開先を作成したディレクトリにしてください。
展開ができたらコマンドプロンプトを起動し、カレントディレクトリをcdコマンドで展開したフォルダに移動します。移動できたら以下のコマンドを実行すればDevKitのインストール完了がします。
ruby dk.rb init
ruby dk.rb install

Nokogiriのインストール

ここで本題のNokogiriのインストールです。以下のコマンドを実行してください。
gem install nokogiri

しばらくまちます。コマンドプロンプトに3gems installと表示されたら完了です。
以下のコマンドを実行してNokogiriのバージョンが表示されれば正しくインストールできています。
nokogiri -v